
// NoticeClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NoticeClient.h"
#include "NoticeClientDlg.h"

#include <array>

#include "SearchDlg.h"
#include "Wingdi.h"

#include "PayloadHdd.h"
#include "PayloadText.h"

#include "..\api\lpng1616\png.h"
#include "..\api\zlib-1.2.8\zlib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CNoticeClientDlg dialog




CNoticeClientDlg::CNoticeClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNoticeClientDlg::IDD, pParent)
	//, m_SocketNotice(this)
	, m_strLocalDirectory(_T(""))
	, m_strLocalDirectory2(_T(""))
	, m_bOverwrite(FALSE)
	, m_iFileFormat(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ENVYLOGIC);
	InitializeCriticalSection(&m_cs);

	m_pBmpImage		= NULL;
	m_lBmpLength	= 0;
	m_bFirst		= FALSE;
	m_lReceiveCount = 0;
	m_bRunning		= FALSE;
	m_hNoticeHandle	= NULL;
    m_strPrefix     = _T("IMG");
}

CNoticeClientDlg::~CNoticeClientDlg()
{
	DeleteCriticalSection(&m_cs);
}


void CNoticeClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_IPADDRESS1, m_ipaddrCtrl);
	DDX_Text(pDX, IDC_EDIT_LOCAL_DIRECTORY, m_strLocalDirectory);
	DDX_Control(pDX, IDC_LIST_LOG, m_listLog);
	DDX_Control(pDX, IDC_BTN_CONNECT, m_btnConnect);
	DDX_Control(pDX, IDC_BTN_DISCONNECT, m_btnDisconnect);
	DDX_Text(pDX, IDC_EDIT_LOCAL_DIRECTORY2, m_strLocalDirectory2);
	DDX_Check(pDX, IDC_CHECK_OVERWRITE, m_bOverwrite);
	DDX_Radio(pDX, IDC_RADIO_BITMAP, m_iFileFormat);
}

BEGIN_MESSAGE_MAP(CNoticeClientDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BTN_SEARCH, &CNoticeClientDlg::OnBnClickedBtnSearch)
	ON_BN_CLICKED(IDC_BTN_CONNECT, &CNoticeClientDlg::OnBnClickedBtnConnect)
	ON_BN_CLICKED(IDC_BTN_DISCONNECT, &CNoticeClientDlg::OnBnClickedBtnDisconnect)
	ON_BN_CLICKED(IDC_BTN_BROWSE, &CNoticeClientDlg::OnBnClickedBtnBrowse)
	ON_MESSAGE(WM_USER_LOG_MESSAGE,	OnLogMessage)
	ON_BN_CLICKED(IDC_BTN_LOGDUMP, &CNoticeClientDlg::OnBnClickedBtnLogdump)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_OPEN, &CNoticeClientDlg::OnBnClickedBtnOpen)
	ON_BN_CLICKED(IDC_BTN_LOGCLEAR, &CNoticeClientDlg::OnBnClickedBtnLogclear)
	ON_BN_CLICKED(IDC_BTN_BROWSE2, &CNoticeClientDlg::OnBnClickedBtnBrowse2)
	ON_BN_CLICKED(IDC_BTN_OPEN2, &CNoticeClientDlg::OnBnClickedBtnOpen2)
	ON_BN_CLICKED(IDC_CHECK_OVERWRITE, &CNoticeClientDlg::OnBnClickedCheckOverwrite)
	ON_BN_CLICKED(IDC_RADIO_BITMAP, &CNoticeClientDlg::OnBnClickedRadioBitmap)
	ON_BN_CLICKED(IDC_RADIO_PNG, &CNoticeClientDlg::OnBnClickedRadioPng)
END_MESSAGE_MAP()


// CNoticeClientDlg message handlers

BOOL CNoticeClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	//   IP 巹 
	CString strAddress = AfxGetApp()->GetProfileString(APP_SECTION_CONNECT, APP_ENTRY_ADDRESS, _T(""));
	if(!strAddress.IsEmpty())
	{
		DWORD dwAddress = GetIPAddress(strAddress);
		m_ipaddrCtrl.SetAddress(dwAddress);
	}

	//    丮 
	m_strLocalDirectory = AfxGetApp()->GetProfileString(APP_SECTION_CONNECT, APP_ENTRY_DIRECTORY, _T(""));
	//    丮 
	m_strLocalDirectory2 = AfxGetApp()->GetProfileString(APP_SECTION_CONNECT, APP_ENTRY_DIRECTORY2, _T(""));

	//   OverWrite ɼ 
	m_bOverwrite = AfxGetApp()->GetProfileInt(APP_SECTION_OPTION, APP_ENTRY_OVERWRITE, 0);

	UpdateData(FALSE);

	UpdateControls();

	//  ĸ ߰
	CString strCaption;
	strCaption.Format("NoticeClient v%d.%d", APP_VERSION_MAJOR, APP_VERSION_MINOR);
	SetWindowText(strCaption);

	// ޸𸮸 ȯ ޸ Ҵ
	m_lBmpLength = 4000 * 3000 * 3;
	m_pBmpImage = new BYTE[m_lBmpLength];
	if(m_pBmpImage == NULL)
	{
		AfxMessageBox("Can't BMP memory allocation!!");
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNoticeClientDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
	if(m_pBmpImage)
	{
		delete [] m_pBmpImage;
		m_pBmpImage = NULL;
		m_lBmpLength = 0;
	}
}

void CNoticeClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNoticeClientDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNoticeClientDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CNoticeClientDlg::OnBnClickedBtnSearch()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CSearchDlg Dlg;
	if(Dlg.DoModal() == IDOK)
	{
		DWORD dwAddress = GetIPAddress(Dlg.m_strSelectAddress);
		m_ipaddrCtrl.SetAddress(dwAddress);
	}
}

void CNoticeClientDlg::OnBnClickedBtnConnect()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);
	if(m_strLocalDirectory.IsEmpty() || m_strLocalDirectory2.IsEmpty())
	{
		AfxMessageBox("Select Local Directories for saving images.");
		return;
	}

	BYTE bField1, bField2, bField3, bField4;
	if(m_ipaddrCtrl.GetAddress(bField1, bField2, bField3, bField4) == 4)
	{
		CString strAddress;
		strAddress.Format("%d.%d.%d.%d", bField1, bField2, bField3, bField4);
		AfxGetApp()->WriteProfileString(APP_SECTION_CONNECT, APP_ENTRY_ADDRESS, strAddress);
		AfxGetApp()->WriteProfileString(APP_SECTION_CONNECT, APP_ENTRY_DIRECTORY, m_strLocalDirectory);
		AfxGetApp()->WriteProfileString(APP_SECTION_CONNECT, APP_ENTRY_DIRECTORY2, m_strLocalDirectory2);
		
		//if(m_SocketNotice.Connect(strAddress, TCP_NOTICE_PORT))
		if(EVN_Connect(&m_hNoticeHandle, strAddress, 3/**/) == EVN_ERR_SUCCESS)
		{
			LogOut("Connect to NoticeServer %s,%s", strAddress, TCP_NOTICE_PORT);

			//  
			m_lReceiveCount = 0;

			// ῡ ϸ ̹   
			m_bRunning = TRUE;
			m_pThread = AfxBeginThread(OnNoticeThread, (LPVOID)(this), 0, 0, CREATE_SUSPENDED, NULL);
			m_pThread->ResumeThread();
		}
		else
		{
			LogOut("Can't connect to NoticeServer %s,%s\n", strAddress, TCP_NOTICE_PORT);
			TRACE("Can't connect to NoticeServer %s,%s\n", strAddress, TCP_NOTICE_PORT);
		}
	}
	else
	{
		AfxMessageBox("Invalid Address");
	}

	UpdateControls();
}

void CNoticeClientDlg::OnBnClickedBtnDisconnect()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	//m_SocketNotice.Disconnect();

	//   flag
	m_bRunning = FALSE;

    //  
	EVN_Disconnect(m_hNoticeHandle);
	LogOut("Disconnect to NoticeServer");

	UpdateControls();
}

// ݹ鿡 ϴ Ķ ü
struct BFFParam
{
	const void* pData;
	bool isString;
};

// ݹ
int CALLBACK _BFFProc(HWND hwnd, UINT msg, LPARAM lparam, LPARAM data)
{
	//  ޽ 
	if (msg == BFFM_INITIALIZED)
	{
		// ̷ ؼ ϴ  ϵ ϸ ȴ.
		BFFParam* pData = (BFFParam*)data;
		if (pData != NULL)
			SendMessage(hwnd, BFFM_SETSELECTION, (pData->isString) ? TRUE : FALSE, (LPARAM)(pData->pData));
	}

	// ٸ   0 ȯؾ Ѵ
	return 0;
}

// title  pInitFolder õǵ   ȭڸ ǥѴ.
PIDLIST_ABSOLUTE browseForFolder(HWND hwnd, LPSTR dispName, const char *title, const void* pInitFolder, bool bIsString)
{
	BFFParam param;
	param.pData		= pInitFolder;
	param.isString	= bIsString;

	BROWSEINFO bi		= {0};
	bi.hwndOwner		= hwnd;
	bi.pszDisplayName	= dispName;
	bi.lpszTitle		= title;
	bi.ulFlags			= BIF_NEWDIALOGSTYLE | BIF_EDITBOX | BIF_RETURNONLYFSDIRS;
	bi.lParam			= (LPARAM)(BFFParam *)&param;
	bi.lpfn				= _BFFProc;
	return SHBrowseForFolder(&bi);
}

void CNoticeClientDlg::OnBnClickedBtnBrowse()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	BROWSEINFO BrInfo;
	TCHAR szBuffer[MAX_PATH];                                      //  

	::ZeroMemory(&BrInfo,sizeof(BROWSEINFO));
	::ZeroMemory(szBuffer, MAX_PATH);

	UpdateData(TRUE);

	LPITEMIDLIST pItemIdList = browseForFolder(GetSafeHwnd(), NULL, NULL, m_strLocalDirectory.GetBuffer(), TRUE);

	//   
	::SHGetPathFromIDList(pItemIdList, szBuffer);

	CString strDirectory = szBuffer;
	if(!strDirectory.IsEmpty())
		m_strLocalDirectory = strDirectory;
	UpdateData(FALSE);

	AfxGetApp()->WriteProfileString(APP_SECTION_CONNECT, APP_ENTRY_DIRECTORY, m_strLocalDirectory);
}

void CNoticeClientDlg::OnBnClickedBtnBrowse2()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	BROWSEINFO BrInfo;
	TCHAR szBuffer[MAX_PATH];                                      //  

	::ZeroMemory(&BrInfo,sizeof(BROWSEINFO));
	::ZeroMemory(szBuffer, MAX_PATH);

	UpdateData(TRUE);

	LPITEMIDLIST pItemIdList = browseForFolder(GetSafeHwnd(), NULL, NULL, m_strLocalDirectory2.GetBuffer(), TRUE);

	//   
	::SHGetPathFromIDList(pItemIdList, szBuffer);

	CString strDirectory = szBuffer;
	if(!strDirectory.IsEmpty())
		m_strLocalDirectory2 = strDirectory;

	UpdateData(FALSE);
	AfxGetApp()->WriteProfileString(APP_SECTION_CONNECT, APP_ENTRY_DIRECTORY2, m_strLocalDirectory2);
}


///////////////////////////////////////////////////////////////////////////////

DWORD CNoticeClientDlg::GetIPAddress(LPCTSTR lpszAddress)
{
	CString strAddress = lpszAddress;
	int a, b, c, d;
	int iRet = sscanf_s(lpszAddress, "%d.%d.%d.%d", &a, &b, &c, &d);
	if(iRet != 4)
		return 0;

	DWORD dwAddress = MAKELONG(MAKEWORD(d, c), MAKEWORD(b, a));
	return dwAddress;
}

LPCTSTR CNoticeClientDlg::GetIPAddress(DWORD dwAddress)
{
	BYTE a, b, c, d;
    a = HIBYTE(HIWORD(dwAddress));  
    b = LOBYTE(HIWORD(dwAddress));  
    c = HIBYTE(LOWORD(dwAddress));  
    d = LOBYTE(LOWORD(dwAddress));

	CString strAddress;
	strAddress.Format("%d.%d.%d.%d", a, b, c, d);
	return strAddress;
}

BOOL CNoticeClientDlg::UpdateResult(PNOTICE_HEADER pHeader, PBYTE pImgData, ULONG lImgLength)
{
	CString strLogMsg;
	__time64_t temp = pHeader->mTimestamp;
	CTime tm(temp);

    char szDateTime[MAX_PATH];
    EVN_GetDateTime(pHeader, szDateTime, MAX_PATH);
    TRACE("UpdateResult DATETIME: %s\n", szDateTime);

	if(pHeader->mType == PACKET_TYPE_RESULT)
	{
		//  ī 
		m_lReceiveCount++;

		switch(pHeader->mPayloadType)
		{
        case PAYLOAD_TYPE_RESULT_IMG:
            {
                CPayloadText payload;
		        if(!payload.parseBinary(pImgData, lImgLength))
			        return FALSE;

                m_strPrefix = _T("IMG");
			    strLogMsg.Format("%04d-%02d-%02d %02d:%02d:%02d.%03d, %s\n", 
                    tm.GetYear(), tm.GetMonth(), tm.GetDay(), tm.GetHour(), tm.GetMinute(), tm.GetSecond(), pHeader->mMillisecond, m_strPrefix);
            }
            break;

        case PAYLOAD_TYPE_RESULT_HDI:
            {
                CPayloadText payload;
		        if(!payload.parseBinary(pImgData, lImgLength))
			        return FALSE;

                m_strPrefix = _T("HDI");

			    strLogMsg.Format("%04d-%02d-%02d %02d:%02d:%02d.%03d, %s, %d, %s, %d\n", 
                    tm.GetYear(), tm.GetMonth(), tm.GetDay(), tm.GetHour(), tm.GetMinute(), tm.GetSecond(), pHeader->mMillisecond, m_strPrefix,
                    pHeader->mPhaseNumber, payload.m_result.c_str(), pHeader->mParameter1);
            }
            break;

        case PAYLOAD_TYPE_RESULT_REEL:
            {
                CPayloadText payload;
		        if(!payload.parseBinary(pImgData, lImgLength))
			        return FALSE;

                m_strPrefix = _T("REEL");

			    strLogMsg.Format("%04d-%02d-%02d %02d:%02d:%02d.%03d, %s, %d, %s, %d\n", 
                    tm.GetYear(), tm.GetMonth(), tm.GetDay(), tm.GetHour(), tm.GetMinute(), tm.GetSecond(), pHeader->mMillisecond, m_strPrefix,
                    pHeader->mPhaseNumber, payload.m_result.c_str(), pHeader->mParameter1);
            }
            break;

        case PAYLOAD_TYPE_RESULT_AFVI:
            {
                CPayloadText payload;
		        if(!payload.parseBinary(pImgData, lImgLength))
			        return FALSE;

                m_strPrefix = _T("AFVI");

			    strLogMsg.Format("%04d-%02d-%02d %02d:%02d:%02d.%03d, %s, %d, %s, %d\n", 
                    tm.GetYear(), tm.GetMonth(), tm.GetDay(), tm.GetHour(), tm.GetMinute(), tm.GetSecond(), pHeader->mMillisecond, m_strPrefix,
                    pHeader->mPhaseNumber, payload.m_result.c_str(), pHeader->mParameter1);
            }
            break;

        case PAYLOAD_TYPE_RESULT_KPCB:
            {
                CPayloadText payload;
		        if(!payload.parseBinary(pImgData, lImgLength))
			        return FALSE;

                m_strPrefix = _T("KPCB");

			    strLogMsg.Format("%04d-%02d-%02d %02d:%02d:%02d.%03d, %s, %d, %s, %d\n", 
                    tm.GetYear(), tm.GetMonth(), tm.GetDay(), tm.GetHour(), tm.GetMinute(), tm.GetSecond(), pHeader->mMillisecond, m_strPrefix,
                    pHeader->mPhaseNumber, payload.m_result.c_str(), pHeader->mParameter1);
            }
            break;

        case PAYLOAD_TYPE_RESULT_BGAB:
            {
                CPayloadText payload;
		        if(!payload.parseBinary(pImgData, lImgLength))
			        return FALSE;

                m_strPrefix = _T("BGAB");

			    strLogMsg.Format("%04d-%02d-%02d %02d:%02d:%02d.%03d, %s, %d, %s, %d\n", 
                    tm.GetYear(), tm.GetMonth(), tm.GetDay(), tm.GetHour(), tm.GetMinute(), tm.GetSecond(), pHeader->mMillisecond, m_strPrefix,
                    pHeader->mPhaseNumber, payload.m_result.c_str(), pHeader->mParameter1);
            }
            break;

        case PAYLOAD_TYPE_RESULT_BGAO:
            {
                CPayloadText payload;
		        if(!payload.parseBinary(pImgData, lImgLength))
			        return FALSE;

                m_strPrefix = _T("BGAO");

			    strLogMsg.Format("%04d-%02d-%02d %02d:%02d:%02d.%03d, %s, %d, %s, %d\n", 
                    tm.GetYear(), tm.GetMonth(), tm.GetDay(), tm.GetHour(), tm.GetMinute(), tm.GetSecond(), pHeader->mMillisecond, m_strPrefix,
                    pHeader->mPhaseNumber, payload.m_result.c_str(), pHeader->mParameter1);
            }
            break;

        case PAYLOAD_TYPE_RESULT_BGAOT:
            {
                CPayloadText payload;
		        if(!payload.parseBinary(pImgData, lImgLength))
			        return FALSE;

                m_strPrefix = _T("BGAOT");

			    strLogMsg.Format("%04d-%02d-%02d %02d:%02d:%02d.%03d, %s, %d, %s, %d\n", 
                    tm.GetYear(), tm.GetMonth(), tm.GetDay(), tm.GetHour(), tm.GetMinute(), tm.GetSecond(), pHeader->mMillisecond, m_strPrefix,
                    pHeader->mPhaseNumber, payload.m_result.c_str(), pHeader->mParameter1);
            }
			break;

		case PAYLOAD_TYPE_RESULT_BRAIL:
            {
                CPayloadText payload;
		        if(!payload.parseBinary(pImgData, lImgLength))
			        return FALSE;

                m_strPrefix = _T("BRAIL");

			    strLogMsg.Format("%04d-%02d-%02d %02d:%02d:%02d.%03d, %s, %d, %s, %d\n", 
                    tm.GetYear(), tm.GetMonth(), tm.GetDay(), tm.GetHour(), tm.GetMinute(), tm.GetSecond(), pHeader->mMillisecond, m_strPrefix,
                    pHeader->mPhaseNumber, payload.m_result.c_str(), pHeader->mParameter1);
            }
			break;
		}

		LogOut(strLogMsg);
		m_fileLog.WriteString(strLogMsg);
		m_fileLog.Flush();

		TRACE(strLogMsg);
	}

	if(pHeader->mType == PACKET_TYPE_IMAGE)
	{
		CString strFileName;
		if(m_bOverwrite)
		{
            strFileName.Format("cap_image%d", pHeader->mPhaseIndex);
		}
		else
		{
			strFileName.Format("%s_%04d%02d%02d_%02d%02d%02d%03d_%d_%d_%d",
                m_strPrefix, tm.GetYear(), tm.GetMonth(), tm.GetDay(), tm.GetHour(), tm.GetMinute(), tm.GetSecond(), 
                pHeader->mMillisecond, pHeader->mPhaseNumber, pHeader->mParameter2, pHeader->mParameter3);
		}

		strFileName = m_strLocalDirectory + "\\" + strFileName;

		if(m_iFileFormat == 0)
		{
			// BMP file
			WriteRGB8(strFileName, pHeader, pImgData, lImgLength);
		}
		else
		{
			// PNG file
			WritePng(strFileName, pHeader, pImgData, lImgLength);
		}
		
	}

    if(pHeader->mType == PACKET_TYPE_COMMAND)
    {
        if(pHeader->mPayloadType == PAYLOAD_TYPE_COMMAND_LIVE)
        {
			strLogMsg.Format("%04d-%02d-%02d %02d:%02d:%02d.%03d, LIVE-PACKET\n", 
                tm.GetYear(), tm.GetMonth(), tm.GetDay(), tm.GetHour(), tm.GetMinute(), tm.GetSecond(), pHeader->mMillisecond);
    		LogOut(strLogMsg);
        }
    }

	return TRUE;
}


void CNoticeClientDlg::UpdateControls()
{
	m_btnConnect.EnableWindow(!(EVN_IsConnect(m_hNoticeHandle) == EVN_ERR_SUCCESS));
	m_btnDisconnect.EnableWindow((EVN_IsConnect(m_hNoticeHandle) == EVN_ERR_SUCCESS));
}

void CNoticeClientDlg::LogOut(char *fmt, ...)
{
	char szMsg[4096];

	if(::IsWindow(GetSafeHwnd()) == FALSE)
		return;

	EnterCriticalSection(&m_cs);

	va_list para;
	va_start(para,fmt);
	vsprintf_s(szMsg, 4096, fmt, para);
	va_end(para);

	m_arOutputLog.Add(szMsg);
	PostMessage(WM_USER_LOG_MESSAGE);

	LeaveCriticalSection(&m_cs);
}

void CNoticeClientDlg::LogOut(LPCTSTR lpszMsg)
{
	if(::IsWindow(GetSafeHwnd()) == FALSE)
		return;

	EnterCriticalSection(&m_cs);

	m_arOutputLog.Add(lpszMsg);
	PostMessage(WM_USER_LOG_MESSAGE);

	LeaveCriticalSection(&m_cs);
}

void CNoticeClientDlg::LogClear()
{
	if(::IsWindow(GetSafeHwnd()) == FALSE)
		return;

	EnterCriticalSection(&m_cs);

	m_listLog.ResetContent();

	LeaveCriticalSection(&m_cs);
}

LRESULT CNoticeClientDlg::OnLogMessage(WPARAM wParam, LPARAM lParam)
{
	EnterCriticalSection(&m_cs);

	for(int i = 0; i < m_arOutputLog.GetSize(); i++)
		m_listLog.AddString(m_arOutputLog[i]);
	m_listLog.SetTopIndex(m_listLog.GetCount() - 1);

	m_arOutputLog.RemoveAll();

	LeaveCriticalSection(&m_cs);

	return 0L;
}

void CNoticeClientDlg::OnBnClickedBtnLogdump()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	// log  ٿε
	static char BASED_CODE szFilter[] = "LOG Files (*.log)|*.log|All Files (*.*)|*.*||";

	CFileDialog Dlg(FALSE, "LOG", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);
	if(Dlg.DoModal() == IDOK)
	{
		CStdioFile file;
		if(file.Open(Dlg.GetPathName(), CFile::modeCreate | CFile::modeWrite | CFile::typeText) == TRUE)
		{
			for(int i = 0; i < m_listLog.GetCount(); i++)
			{
				CString strLine;
				m_listLog.GetText(i, strLine);
				strLine += "\r\n";
				file.WriteString(strLine);
			}

			file.Close();
			LogOut("Log File saved: %s", Dlg.GetPathName());
		}
	}
}

void CNoticeClientDlg::MakeBmpHeader(BITMAPINFOHEADER *pbmiHdr, BITMAPFILEHEADER *pbmfHdr, ULONG lWidth, ULONG lHeight)
{
	// 8Ʈ BMP Header
	memset(pbmfHdr, 0, sizeof(BITMAPFILEHEADER));
	pbmfHdr->bfType			= ((WORD)'M'<<8 | 'B');
	pbmfHdr->bfSize			= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + 1024 + (lWidth * lHeight);
	pbmfHdr->bfReserved1	= 0;
	pbmfHdr->bfReserved2	= 0;
	pbmfHdr->bfOffBits		= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + 1024/* palette ũ */;

	memset(pbmiHdr, 0, sizeof(BITMAPINFOHEADER));
	pbmiHdr->biSize			= sizeof(BITMAPINFOHEADER);
	pbmiHdr->biWidth		= lWidth;
	pbmiHdr->biHeight		= lHeight;
	pbmiHdr->biPlanes		= 1;
	pbmiHdr->biBitCount		= 8;
	pbmiHdr->biCompression	= BI_RGB;
	pbmiHdr->biSizeImage	= (lWidth * lHeight);
}

void CNoticeClientDlg::YtoRGB8(PBYTE pYuvBuf, ULONG lYuvLength, 
							 PBYTE pBmpBuf, ULONG lBmpLength, ULONG lWidth, ULONG lHeight)
{
	// BMP ޸ ʱȭ
	memset(pBmpBuf, 0, lBmpLength);

	// δ 
	int b_line_length = lBmpLength / lHeight;

	// YUV BMP  ŸƮ ε
	int	y_line_start, b_line_start;

	for(ULONG i = 0; i < lHeight;i++) 
	{
		y_line_start = i * lWidth;
		// BMP Ʒ   ϵȴ.
		b_line_start = (lHeight - i - 1) * b_line_length;

        for(ULONG j = 0 ; j < lWidth ; j++) 
		{
            pBmpBuf[b_line_start + j] = pYuvBuf[y_line_start + j];
		}
	}
}

void CNoticeClientDlg::WriteRGB8(LPCTSTR lpszFileName, PNOTICE_HEADER pHeader, PBYTE pImgData, ULONG lImgLength)
{
	BITMAPINFOHEADER bmiHdr;
	BITMAPFILEHEADER bmfHdr;

	// ̸ Ȯ ߰
	CString strFileName = lpszFileName;
	strFileName += ".bmp";
	TRACE("WriteRGB8: %s\n", (LPCTSTR)strFileName);

	// IMAGE info
	ULONG lWidth = pHeader->mParameter2;
	ULONG lHeight= pHeader->mParameter3;

	//   Ʈ 
	ULONG lWLength = lWidth;
	// 4Ʈ   Padding byte ߰
	while(lWLength % 4 != 0)
		lWLength++;
	// е  ü ޸ ũ
	ULONG lBmpLength = lWLength * lHeight;
	TRACE("IMAGE: W %d- H %d, L %d\n", lWidth, lHeight, lWLength);

	// Y -> RGB8 Convert
	YtoRGB8(pImgData, lImgLength, m_pBmpImage, lBmpLength, lWidth, lHeight);

	// RGB8 BMP HEADER
	MakeBmpHeader(&bmiHdr, &bmfHdr, lWidth, lHeight);

	// PALETTE 
	RGBQUAD pal[256];
	for(int i = 0; i < 256; i++)
	{
		pal[i].rgbBlue		= i;
		pal[i].rgbGreen		= i;
		pal[i].rgbRed		= i;
		pal[i].rgbReserved	= 0;
	}

	//  
	CFile bmpFile;
	CString strBmpPath = strFileName;
	if(bmpFile.Open(strBmpPath, CFile::modeCreate | CFile::modeWrite | CFile::typeBinary))
	{
		bmpFile.Write(&bmfHdr, sizeof(BITMAPFILEHEADER));
		bmpFile.Write(&bmiHdr, sizeof(BITMAPINFOHEADER));
		bmpFile.Write(pal, sizeof(RGBQUAD) * 256);
		bmpFile.Write(m_pBmpImage, lBmpLength);
		bmpFile.Flush();
		bmpFile.Close();
	}
}

void CNoticeClientDlg::WritePng(LPCTSTR lpszFileName, PNOTICE_HEADER pHeader, PBYTE pImgData, ULONG lImgLength)
{
	// ̸ Ȯ ߰
	CString strFileName = lpszFileName;
	strFileName += ".png";
	TRACE("WritePng: %s\n", (LPCTSTR)strFileName);

	// PNG
	int iErrCode = EVN_SavePngFile(strFileName, pHeader, pImgData, lImgLength);
	if(iErrCode != EVN_ERR_SUCCESS)
	{
        CString strErrMsg;
        strErrMsg.Format("Error = %X, %s\n", iErrCode, EVN_GetErrMsg(iErrCode));
        LogOut(strErrMsg);
		TRACE(strErrMsg);
	}
}


void CNoticeClientDlg::OnBnClickedBtnOpen()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);
	ShellExecute(NULL, _T("open"), m_strLocalDirectory, NULL, NULL, SW_SHOW);
}

void CNoticeClientDlg::OnBnClickedBtnLogclear()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	LogClear();
}

void CNoticeClientDlg::OnBnClickedBtnOpen2()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);
	ShellExecute(NULL, _T("open"), m_strLocalDirectory2, NULL, NULL, SW_SHOW);
}

void CNoticeClientDlg::OnBnClickedCheckOverwrite()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);
	AfxGetApp()->WriteProfileInt(APP_SECTION_OPTION, APP_ENTRY_OVERWRITE, m_bOverwrite);
}

void CNoticeClientDlg::OnBnClickedRadioBitmap()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);
}

void CNoticeClientDlg::OnBnClickedRadioPng()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);
}

// NOTICE ͸ ϱ  
UINT CNoticeClientDlg::OnNoticeThread(LPVOID pParam)
{
	CNoticeClientDlg *pDlg = (CNoticeClientDlg *)pParam;
	return pDlg->Capture();
}

// ĸ 
int CNoticeClientDlg::Capture()
{
	CTime time =CTime::GetCurrentTime();
	CString strFileName;
	strFileName.Format("log_%04d%02d%02d_%02d%02d%02d.log", 
		time.GetYear(), time.GetMonth(), time.GetDay(), time.GetHour(), time.GetMinute(), time.GetSecond());
	strFileName = m_strLocalDirectory + "\\" + strFileName;

	if(m_fileLog.Open(strFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone) == FALSE)
	{
		TRACE("Can't open log file: %s\n", strFileName);
		EVN_Disconnect(m_hNoticeHandle);
		return EVN_ERR_SUCCESS;
		//m_SocketNotice.Disconnect();
	}

	while(m_bRunning)
	{
		unsigned char *pPayload = NULL;
		int iLength = 0, iPayloadLength = 0;

		// blocked  1̸ ̹   ٸ.
		// blocked  0̸ ̹   
		int ret = EVN_GetNotice(m_hNoticeHandle, 1/*blocked*/, &iLength, &m_Header, &pPayload, &iPayloadLength);
        if (ret == EVN_ERR_SUCCESS) 
		{
			TRACE("EVN_GetNotice - length: %d\n", iLength);
			// ŵ ̹ ó
			UpdateResult(&m_Header, pPayload, iPayloadLength);
		}
        else if(ret == EVN_ERR_NOTICEMGR_BUFFER_EMPTY)
		{
			TRACE("Error = %X, %s\n", ret, EVN_GetErrMsg(ret));
			Sleep(10);
		}
		else 
        {
            CString strErrMsg;
            strErrMsg.Format("Error = %X, %s\n", ret, EVN_GetErrMsg(ret));
            LogOut(strErrMsg);
			TRACE(strErrMsg);
            OnBnClickedBtnDisconnect();         
        }
	}

    if(m_fileLog.m_hFile != CFile::hFileNull)
	    m_fileLog.Close();

	return EVN_ERR_SUCCESS;
}


